<?
	require_once('iniclasses.inc.php');
	require_once('xml2array.inc.php');
	require_once('const.inc.php');
	require_once('paths.inc.php');
	require_once('funcs.inc.php');


	// Var-Initialisierungen
	$strShare = '';
	$strPath = '';
	$strComment='';
	$strCreateMask = '';
	$strDirectoryMask = '';
	$nBrowseable=0;
	$nReadonly=0;
	$nPublic=0;

	$strError = '';
	$strMessage = '';
	$bConfirmed=false;
	$nVisMode=0; 	// Modus fuer Anzeigemodul

	// *****************************************************
	//                        SMB.CONF
	// *****************************************************
	
	// Ein neues iniFile-Objekt erzeugen
	$objSmb = new iniFile($strConfPath, $strOutPath);
	
	// Alles in ein Array umwandeln
	$objSmb->toArray();
	

	// *****************************************************
	//                         XML
	// *****************************************************
	
	// Array fuer Parameter-Informationen
	$arrXml = xmlFileToArray($strXmlPath );

	// verwendete Abschnitte der XML-Steuerdatei einlesen
	$arrShare = getParam($arrXml,'#meta#','#share#');
	if (!is_array($arrShare))
		die("### XML-File '$arrXml' could not be read");

	$arrShareParams = getNamedParamArray($arrXml,'#share#');
	
		
	// Parameter einlesen
	$strShare = $_POST['f_share'];
	$strPath = $_POST['f_path'];

	$strComment = $_POST['f_comment'];
	$strCreateMask = $_POST['f_create_mask'];
	$strDirectoryMask = $_POST['f_directory_mask'];;
	
	$nBrowseable = GetCheckboxValAsInt('f_browseable');
	$nReadonly = GetCheckboxValAsInt('f_read_only');
	$nPublic = GetCheckboxValAsInt('f_public');


	if (isset($_POST['f_confirmed']))
		$bConfirmed=true;
	else
		$bConfirmed=false;
				
	// Validierungen
	if (strlen($strShare) < 1)
	{
		$strError="Freigabe-Name ist zu kurz";
		$nVisMode=MODE_CRSH_ERROR;
	}
	elseif (strlen($strPath) < 2)
	{
		$strError="Pfadname ist zu kurz";
		$nVisMode=MODE_CRSH_ERROR;
	}
	elseif (!ereg($arrShare['validation'], $strShare))
	{
		$strError="Freigabe-Name enth&auml;lt nicht erlaubte Zeichen";
		$nVisMode=MODE_CRSH_ERROR;
	}
	elseif (isset($objSmb->arrEntries[$strShare]))
	{
		$strError= "Der Freigabe-Name wird in der Samba-Konfiguration bereits verwendet";
		$nVisMode=MODE_CRSH_ERROR;
	}
	elseif (!ereg($arrShareParams['path']['validation'], $strPath))
	{
		$strError="Der Pfad-Name ist ung&uuml;ltig";
		$nVisMode=MODE_CRSH_ERROR;
	}
	elseif (!ereg($arrShareParams['create mask']['validation'], $strCreateMask))
	{
		$strError="Die Create Maske enth&auml;lt ung&uuml;ltige Zeichen";
		$nVisMode=MODE_CRSH_ERROR;
	}
	elseif (!ereg($arrShareParams['directory mask']['validation'], $strDirectoryMask))
	{
		$strError="Die Directory Maske enth&auml;lt ung&uuml;ltige Zeichen";
		$nVisMode=MODE_CRSH_ERROR;
	}
	elseif (file_exists($strPath) && !$bConfirmed) 
	{
		$strError="###Es gibt schon ein Verzeichnis '$strPath'";
		$nVisMode=MODE_CRSH_CONFIRM;
	}
	else
	{
		// Freigabe kreieren, falls notwendig
		if (!file_exists($strPath))
			$strCommandResponse = shell_exec("sudo $strMakeDirectory $strPath 2>&1");
			
		if (strlen($strCommandResponse)==0)
			{
				// Pfad anlegen hat geklappt...nun smb.conf anpassen
				
				// Neue Werte in der neuen Freigabe Sektion anlegen
				$objSmb->addEntry($strShare,'path',$strPath);
				$objSmb->addEntry($strShare,'comment',$strComment);
				$objSmb->addEntry($strShare,'create mask',$strCreateMask);
				$objSmb->addEntry($strShare,'directory mask',$strDirectoryMask);
				$objSmb->addEntry($strShare,'browseable',Int2YesNo($nBrowseable));
				$objSmb->addEntry($strShare,'read only',Int2YesNo($nReadonly));
				$objSmb->addEntry($strShare,'public',Int2YesNo($nPublic));
				
				// Die &auml;nderungen schreiben
				$objSmb->writeIniFile();
				
				$strCommandResponse = nl2br(shell_exec("sudo $strStartNewConf 2>&1"));
				$strMessage = $strCommandResponse;				   
				$nVisMode=MODE_CRSH_DONE;
		}
		else
		{
			$strError = "Bei der Anlage des Freigabe-Pfads '$strShare' trat folgender Fehler auf: '$strCommandResponse'";
			$nVisMode=MODE_CRSH_ERROR;
		}
	}

// wieder den Visualisierungs-Teil aufrufen	

header(sprintf('Location: create_share_vis.php?f_mode=%d&f_message=%s&f_error=%s&f_share=%s&f_path=%s&f_comment=%s&f_create_mask=%s&f_directory_mask=%s&f_browseable=%d&f_read_only=%d&f_public=%d',
	$nVisMode,
	rawurlencode($strMessage),
	rawurlencode($strError),
	rawurlencode($strShare),
	rawurlencode($strPath),
	rawurlencode($strComment),
	rawurlencode($strCreateMask),
	rawurlencode($strDirectoryMask),
	$nBrowseable,
	$nReadonly,
	$nPublic)
	); 		
?>